mob //you
	icon = 'icons.dmi'
	icon_state = "person"
	Login()
		src<<"Buy the house and start laying objects!"
		src.loc = locate(1,1,1)
turf
	icon = 'icons.dmi'
	grass
		icon_state = "grass"
	house //adding another part of the path
		woodfloor //this is where the objects have to be on to be saved
			icon_state = "floor"
	wall
		density = 1 //cannot go through this
		icon_state = "wall"
obj //the things you can build
	icon = 'icons.dmi'
	chair
		icon_state = "chair"
	bed
		icon_state = "bed"
	table
		icon_state = "table"
	var              //These next few variables are so you can store the object's 'x','y', and 'z'
		saveX = 0
		saveY = 0
		saveZ = 0
turf
	var
		saveX = 0     //saves for the doormatt's 'x','y', and 'z'
		saveY = 0
		saveZ = 0
		list
			owner = list()    //A list with all the people allowed in the house

	doormatt  //The "door matt" that the player will step on to see if he owns the house and if he wants to buy it
		icon_state = "doormatt"
		Enter(mob/M) //When the player attempts to enter the house
			if(src.owner.len == 0) //if no one owns the house
				switch(alert(M,"Do you wish to buy this house?","Buying House","Yes","No")) //makes a pop up that will as if the player wishes to buy the house, comes with two options..Yes and No
					if("Yes") //if the player picked Yes
						M<<"Welcome to your new house"
						src.owner.Add(M.key) //Adds M.key to the owner list
						return 1 //lets the player enter the loc of the doormatt
					if("No") //if the player chose No
						return 0 //won't let the player enter doormatt's loc
			else //if it is owned by somebody
				if(M.key in src.owner) //if M.key is the src.owner's list
					return 1 //it lets the player in
				else //if they player does not own the house
					M<<"This isn't your house!!!"
					return 0 //it won't let the player in
var/list/HouseStuff = list() //the variable that will store all the information
world/New() //when the world is created
	if(fexists("House.sav")) //if the file "House.sav" exists
		var/savefile/F = new("House.sav") //makes F equal what's in "House.sav"
		F >> HouseStuff //Takes what is in F and puts it in HouseStuff
		for(var/obj/O in HouseStuff) //for all the objects in HouseStuff
			if(istype(O,/obj)) //if O is an object
				O.loc = locate(O.saveX,O.saveY,O.saveZ) //Places O where it last was
		for(var/turf/T in HouseStuff) //For all the turfs in HouseStuff
			if(istype(T,/turf/doormatt)) //Make sure T is a turf
				for(var/turf/S in world) //For all the turfs in world's contents
					if(istype(S,/turf/doormatt)) //Make sure S is a doormatt
						if(S.loc == locate(T.saveX,T.saveY,T.saveZ)) //if S's loc equals T's last loc
							S.owner = T.owner //S's owner now becomes T's owner
				HouseStuff.Remove(T) //Removes T from HouseStuff
world/Del() //When the world is deleted
	var/savefile/F //creates a variable F, which is a savefile
	F = new("House.sav") //F is "House.sav"
	for(var/turf/T in world) //for all the turf in the world
		if(istype(T,/turf/doormatt)) //make sure T is a tuf
			T.saveX = T.x //T's last loc is recorded with these
			T.saveY = T.y
			T.saveZ = T.z
			HouseStuff.Add(T) //Add T in HouseStuff
		if(istype(T,/turf/house/woodfloor)) //if T is a woodenfloor
			for(var/obj/O in T) //for all objects that are at T's loc
				O.saveX = O.x //records the object's last location
				O.saveY = O.y
				O.saveZ = O.z
				HouseStuff.Add(O) //Adds O to HouseStuff
	F << HouseStuff
mob/verb/Lay_Object() //The verb so the player can lay objects
	switch(alert(src,"What type of object do you wish to lay?","Laying Objects","Chair","Table","Bed")) //asks what type of object
		if("Chair") //if the player chose "Chair"
			new/obj/chair(src.loc) //creates a chair at the player's location
		if("Table")//if the player chose "Table"
			new/obj/table(src.loc)//creates a table at the player's location
		if("Bed")//if the player chose "Bed"
			new/obj/bed(src.loc)//creates a bed at the player's location
mob/verb/Invite_Person(var/mob/M in world) //to invite a person to come in your house
	var/check = 0 //One of my check variables, something I do not sure if others do
	if(M.client) //If M is another player
		for(var/turf/T in world) //for all the turfs in world
			if(istype(T,/turf/doormatt)) //if the turf is a doormatt
				if(src.key in T.owner) //if the player's key is in the turf's owner
					check = 1 //Ok the player does own a house
					T.owner.Add(M.key)  //add M's key to the owner list
					M<<"[src] invited you to his house!"
					src<<"You invited [M] to your house!"
		if(check == 0) //if the player didn't own a house
			src<<"You don't own a house!"